#include <avr/io.h>
#include "peri.h"

void init_peri() {
    DDRC |= (1<<PC3) | (1<<PC2) | (1<<PC1) | (1<<PC0);

    DDRB &= ~((1<<PB0)|(1<<PB1)|(1<<PB2)|(1<<PB3));

    PORTB |= (1<<PB3) | (1<<PB2) | (1<<PB1) | (1<<PB0);

    set_green_value(0);
    set_yellow_value(0);
    set_red_value(0);
    set_blue_value(0);
}

void set_green_value(uint8_t value) {
    PORTC &= ~(0b1);
    PORTC |= value;
}


void set_yellow_value(uint8_t value) {
    value = (value<<1);
    PORTC &= ~(1<<1);
    PORTC |= value;
}


void set_red_value(uint8_t value) {
    value = (value<<2);
    PORTC &= ~(1<<2);
    PORTC |= value;
}


void set_blue_value(uint8_t value) {
    value = (value<<3);
    PORTC &= ~(1<<3);
    PORTC |= value;
}


uint16_t read_adc(uint8_t channel) {
    ADMUX = (0<<REFS1)|(1<<REFS0)
          | (0<<ADLAR)
          | (channel & 0b1111);

    ADCSRA = (1<<ADEN)
           | (1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)
           | (1<<ADSC);

    while ((ADCSRA & (1<<ADSC)))
        ;
    return ADCL + ADCH*256;
}
